<div class="input-options-panel" ...attributes {{did-insert this.checkDefaultValues}} {{did-update this.updateConfig @config}} {{did-update this.updateValue @value}}>
  {{#each this.config as |field|}}
    {{#if field.options}}
      <Editor::Properties::OptionContainer @label={{t (concat "option-panel." field.class)}} as |id|>
        <Input::Select class="{{field.class}}" id={{id}} @list={{field.options}} @value={{field.value}} @onChange={{fn this.change field.name field.type}} />
      </Editor::Properties::OptionContainer>
    {{else if (eq field.type "bool")}}
      <Editor::Properties::OptionContainer @label={{t (concat "option-panel." field.class)}} as |id|>
        <Input::SelectBoolean class="{{field.class}}" id={{id}} @value={{field.value}} @onChange={{fn this.change field.name field.type}} />
      </Editor::Properties::OptionContainer>
    {{else if (eq field.type "color")}}
      <Input::BsColorPicker @space={{@space}} @label={{t (concat "option-panel." field.class)}} @onChange={{fn this.change field.name field.type}} @value={{field.value}} />
    {{else if (eq field.type "border")}}
      <Editor::Properties::Border @classes={{this.classes}} @onChange={{this.changeClasses}} />
    {{else if (eq field.type "text-style")}}
      <Editor::Properties::Text @value={{this.value}} @onChange={{this.changeWithMerge}} />
    {{else if (eq field.type "button-style")}}
      <Editor::Properties::ButtonStyleOptions @space={{@space}} @value={{this.classes}} @onChange={{this.changeClasses}} />
    {{else if (eq field.type "padding")}}
      <Input::Options::PaddingsPanel @label={{t "option-panel.padding"}} @options={{this.classes}} @onChangeOptions={{this.changeClasses}} />
    {{else if (eq field.type "margin")}}
      <Input::Options::MarginsPanel @label={{t "option-panel.margin"}} @prefix="m" @options={{this.classes}} @onChangeOptions={{this.changeClasses}} />
    {{else if (eq field.type "width-percentage")}}
      <Editor::Properties::ResponsiveValue @label={{t "option-panel.bs-property-width"}} as |size|>
        <Editor::Properties::Width @size={{size}} @options={{this.classes}} @onChange={{this.changeClasses}} />
      </Editor::Properties::ResponsiveValue>
    {{else if (eq field.type "width")}}
      <Input::Options::WidthsPanel @label={{t "option-panel.width"}} @value={{this.value}} @onChangeOptions={{this.changeWithMerge}} />
    {{else if (eq field.type "title")}}
      <h5 class="mt-3">{{field.name}}</h5>
    {{else if (eq field.type "px")}}
      <Input::Options::SizePx @property={{field.name}} @value={{this.state.style}} @onChange={{this.changeCss}} />
    {{else if (eq field.type "link")}}
      <Editor::Properties::OptionContainer @label={{t (concat "option-panel." field.class)}} as |id|>
        <Editor::Properties::Link id={{id}} @label={{t "option-panel.destination"}} @value={{field.value}} @onChange={{fn this.change field.name field.type}} @space={{@space}} />
      </Editor::Properties::OptionContainer>
    {{else if (eq field.type "bs")}}
      <Editor::Properties::ResponsiveValue @label={{t (concat "option-panel.bs-property-" field.property)}} @onDeviceSizeChange={{@onDeviceSizeChange}} as |size|>
        {{#component (concat "editor/properties/" field.property) options=this.classes size=size onChange=this.changeClasses}}{{/component}}
      </Editor::Properties::ResponsiveValue>
    {{else if field.type}}
      <Editor::Properties::OptionContainer @label={{t (concat "option-panel." field.class)}} as |id|>
        <Input::Text class="form-control {{field.class}}" id={{id}} @value={{field.value}} @type={{field.type}} @onChange={{fn this.change field.name field.type}} />
      </Editor::Properties::OptionContainer>
    {{/if}}
  {{/each}}
</div>